/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : BrowserBuild.h
 * DATE   : 24.09.2006
 *******************************************************************/
#ifndef INCLUDED_BrowserBuild_h
#define INCLUDED_BrowserBuild_h

/*------- include files:
-------------------------------------------------------------------*/
#include <QTextBrowser>
#include <QSyntaxHighlighter>
#include <QTime>

/*------- forward declaration:
-------------------------------------------------------------------*/
class QEvent;
class Event;

/*------- class declaration:
-------------------------------------------------------------------*/
class BrowserBuild : public QTextBrowser
{
   Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION *******
public:
   explicit BrowserBuild( QWidget* = 0 );
   ~BrowserBuild();
private:
   BrowserBuild( const BrowserBuild& );
   BrowserBuild& operator=( const BrowserBuild& );

// ******* CONSTANTS *******
private:
   static const char* const FINISH;
   static const char* const ELAPSED;

// ******* TYPES ******
private:
   class SyntaxHighlighter : public QSyntaxHighlighter
   {
   public:
      explicit SyntaxHighlighter( QTextDocument* in_doc )
      : QSyntaxHighlighter( in_doc )
      {}
   private:
      SyntaxHighlighter( const SyntaxHighlighter& );
      SyntaxHighlighter& operator=( const SyntaxHighlighter& );
      void highlightBlock( const QString& );   
   };

// ******* MEMBERS *******
private:
   QPalette           org_palette_;
   QFont              org_font_;
   SyntaxHighlighter* syntax_;
   QTime              time_;

// ******* METHODS *******
private:
   void customEvent    ( QEvent* );
   void set_properties ();
   void add_line       ( Event* );
   void process_broken ();
};

#endif // INCLUDED_BrowserBuild_h
