/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : Cobras.cpp
 * DATE   : 2.09.2006
 *******************************************************************/
 
/*------- include files:
-------------------------------------------------------------------*/
#include "MainWindow.h"
#include "Config.h"
#include "Classer.h"
#include "Shared.h"
#include "Bookmarks.h"
#include "Breakpoints.h"
#include "Translator.h"
#include "QtMake.h"
#include "QBtPrinter.h"
#include "EventsController.h"
#include <QIcon>
#include <QApplication>

//*******************************************************************
// main
//*******************************************************************
int main( int in_argc, char** in_argv )
{
   Q_INIT_RESOURCE( cobras );

   QCoreApplication::setOrganizationName  ( Shared::ORGANISATION );
   QCoreApplication::setOrganizationDomain( Shared::ORGANISATION );
   QCoreApplication::setApplicationName   ( Shared::PROGRAM_NAME );
   
   QApplication app( in_argc, in_argv );
   Config::instance();
   Classer::instance();
   Bookmarks::instance();
   Breakpoints::instance();
   QtMake::instance();
   EventsController::instance();
   QBtPrinter::instance();
   
   Translator::instance()->restore();
   
   app.setWindowIcon( QIcon( ":/img/cobras.png" ) );
   MainWindow main_window;
   main_window.show();
   const int retval = app.exec();

   return retval;
}
// end of main
