/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : DataTable.h
 * DATE   : 10.03.2007
 *******************************************************************/
#ifndef INCLUDED_DataTable_h
#define INCLUDED_DataTable_h

/*------- include files:
-------------------------------------------------------------------*/
#include <QTableWidget>
#include <QRgb>

/*------- class declaration:
-------------------------------------------------------------------*/
class DataTable : public QTableWidget
{
	Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION *******
public:
	DataTable( QWidget*, qint32 = 2, bool = true, qint32 = 6 );
private:
	DataTable( const DataTable& );
	DataTable& operator=( const DataTable& );

// ******* CONSTANTS *******
private:
	static const QRgb   GRAY;

// ******* MEMBERS *******
private:
	const qint32              d_X_width;
	qint32                    d_n_char_width;
	const qint32              d_row_height;
protected:
	bool                      d_set_min_width;

// ******* METHODS *******
public:
	void             showEvent ( QShowEvent* );
	void           resizeEvent ( QResizeEvent* );
	bool                  edit ( const QModelIndex&, EditTrigger, QEvent* );
	qint32             add_row ( const qint32 = -1 );
	void           remove_rows ( qint32 );
	void              set_item ( qint32, qint32, const QString& );
	bool              get_item ( qint32, qint32, QString& );
	void          set_tool_tip ( qint32, qint32, const QString& );
	bool          get_tool_tip ( qint32, qint32, QString& );
	void        resize_columns ();
	qint32 total_columns_width ();
	void           resize_rows ();
};

#endif // INCLUDED_DataTable_h
