/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : DbgRegisters.h
 * DATE   : 16.02.2007
 *******************************************************************/
#ifndef INCLUDED_DbgRegisters_h
#define INCLUDED_DbgRegisters_h

/*------- include files:
-------------------------------------------------------------------*/
#include "DbgToolDialog.h"
#include "DbgDataTable.h"

/*------- forward declarations:
-------------------------------------------------------------------*/
class Event;

/*------- class declaration:
-------------------------------------------------------------------*/
class DbgRegisters : public DbgToolDialog
{
	Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION *******
public:
	DbgRegisters( QWidget* = 0 );
	~DbgRegisters();
private:
	DbgRegisters( const DbgRegisters& );
	DbgRegisters& operator=( const DbgRegisters& );

// ******* LOCAL CONSTANTS *******
private:
	static const char* const CAPTION;
	static const QString     ERROR;

// ******* MEMBERS *******
private:
	DbgDataTable* const d_table;

// ******* METHODS *******
private:
	void   showEvent ( QShowEvent* );
	void  closeEvent ( QCloseEvent* );
	void customEvent ( QEvent* );
	void  parse_data ( Event* );
	void    set_item ( qint32, const QString& );
	void      finish ();
};

#endif // INCLUDED_DbgRegisters_h
