/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : GotoLine.h
 * DATE   : 23.09.2006
 *******************************************************************/
#ifndef INCLUDED_GotoLine_h
#define INCLUDED_GotoLine_h

/*------- include files:
-------------------------------------------------------------------*/
#ifndef INCLUDED_QDialog
#define INCLUDED_QDialog
#include <QDialog>
#endif // INCLUDED_QDialog

#ifndef INCLUDED_QComboBox
#define INCLUDED_QComboBox
#include <QComboBox>
#endif // INCLUDED_QComboBox

/*------- forward declarations:
-------------------------------------------------------------------*/
class QVBoxLayout;
class QHBoxLayout;
class QPushButton;
class QShowEvent;

/*------- class declaration:
-------------------------------------------------------------------*/
class GotoLine : public QDialog
{
	Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION *******
public:
	explicit GotoLine( QWidget* );
	~GotoLine();
private:
	GotoLine( const GotoLine& );
	GotoLine& operator=( const GotoLine& );

// ******* CONSTANTS *******
private:
	static const char* const CAPTION;
	static const char* const GOTO;
	static const char* const CANCEL;

// ******* MEMBERS *******
private:
	QVBoxLayout* const d_main_layout;
	QHBoxLayout* const d_input_layout;
	QHBoxLayout* const d_btn_layout;
	QComboBox*   const d_input;
	QPushButton* const d_go;
	QPushButton* const d_cancel;

// ******* TYPES *******
private:
	enum {
		MAX_ITEMS_NUMBER = 10
	};
// ******* METHODS *******
private:
	void showEvent( QShowEvent* );
	void save_data();
	void restore_data();
private slots:
	void accept();
	//void editing_finished();
public:
	int value() const { return d_input->currentText().toInt(); }
};

#endif // INCLUDED_GotoLine_h
