/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : Process.h
 * DATE   : 24.09.2006
 *******************************************************************/
#ifndef INCLUDED_Process_h
#define INCLUDED_Process_h

/*------- include files:
-------------------------------------------------------------------*/
#include <QProcess>
#include <QStringList>

/*------- class declaration:
------------------------------------------------------------------*/
class Process : public QProcess
{
	Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION *******
public:
	Process();
private:
	Process( const Process& );
	Process& operator=( const Process& );

// ******* CONSTANTS *******
private:
	static const char* const PROCESSING;
	static const QString     MSG;

// ******* MEMBERS *******
private:
	QStringList                 commands_;
	bool                        first_time_;
	QStringList::const_iterator it_;

	

// ******* METHODS *******
public:
	void run             ( const QString&, const QStringList& );
private slots:
	void read_stdout     ();
	void read_stderr     ();
	void process_started ();
	void process_finished( int );
	void process_error   ( QProcess::ProcessError );
};

#endif // INCLUDED_Process_h
