/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : ProjectCppFilesWidget.h
 * DATE   : 14.12.2006
 *******************************************************************/
#ifndef INCLUDED_ProjectCppFilesWidget_h
#define INCLUDED_ProjectCppFilesWidget_h

/*------- include files:
-------------------------------------------------------------------*/
#include "ProjectFilesWidget.h"
#include <QStringList>

/*------- class declaration:
-------------------------------------------------------------------*/
class ProjectCppFilesWidget : public ProjectFilesWidget
{
   Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION *******
public:
   ProjectCppFilesWidget( ProjectProp* , QWidget* = 0 );
private:
   ProjectCppFilesWidget( const ProjectCppFilesWidget& );
   ProjectCppFilesWidget& operator=( const ProjectCppFilesWidget& );

// ******* CONSTANTS *******
private:
   static const char* const CAPTION;

// ******* METHODS *******
public:
   bool accept() const;
private:
   bool fname_is_valid( QStringList& inout_flist );
};

#endif // INCLUDED_ProjectCppFilesWidget_h
