/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : ProjectFilesWidget.h
 * DATE   : 14.12.2006
 *******************************************************************/
#ifndef INCLUDED_ProjectFilesWidget_h
#define INCLUDED_ProjectFilesWidget_h

/*------- include files:
-------------------------------------------------------------------*/
#include "ProjectProp.h"
#include <QWidget>
#include <QStringList>

/*------- forward declarations:
-------------------------------------------------------------------*/
class QListWidget;


/*------- class declaration:
-------------------------------------------------------------------*/
class ProjectFilesWidget : public QWidget
{
   Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION *******
public:
   ProjectFilesWidget( ProjectProp* in_project_prop, QWidget* in_parent = 0 );
private:
   ProjectFilesWidget( const ProjectFilesWidget& );
   ProjectFilesWidget& operator=( const ProjectFilesWidget& );

// ******* CONSTANTS *******
protected:
   static const char* const MSG_MULTI;
   static const char* const MSG_SINGLE;
   static const char* const CAPTION_CREATE;
   static const char* const CANT_CREATE;

// ******* MEMBERS *******
private:
   ProjectProp* const d_project_prop;
   QListWidget* const d_list;
   QString            d_dir;
   QStringList        d_set_files;
   QStringList        d_out_files;
protected:
   QStringList        d_filters;

// ******* METHODS *******
public:
   void get_data( QStringList& out_files );
   void set_data( const QStringList& in_files );
   bool changed();
   bool empty() const;
protected:
   virtual bool fname_is_valid( QStringList& inout_flist ) = 0;
private:
   void keyPressEvent( QKeyEvent* in_event );
   void showEvent( QShowEvent* in_event );
   void add_file_to_list( const QString& in_fpath );
private slots:
   void add_slot();
   void del_slot();
};

#endif // INCLUDED_ProjectFilesWidget_h
