/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : ProjectTools.h
 * DATE   : 21.05.2007
 *******************************************************************/
#ifndef INCLUDED_ProjectTools_h
#define INCLUDED_ProjectTools_h

/*------- include files:
-------------------------------------------------------------------*/
#include <QWidget>

/*------- forward declarations:
-------------------------------------------------------------------*/
class QLineEdit;
class ToolsTable;

/*------- class declaration:
-------------------------------------------------------------------*/
class ProjectTools : public QWidget
{
	Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION *******
public:
	ProjectTools( QWidget* = 0 );
	~ProjectTools();
private:
	ProjectTools( const ProjectTools& );
	ProjectTools operator=( const ProjectTools& );

// ******* CONSTANTS *******
private:
	static const char* const QT_MAKE;
	static const char* const BEFORE_QMAKE;
	static const char* const AFTER_QMAKE;
	static const char* const UP_ITEM;
	static const char* const DOWN_ITEM;
	static const char* const ADD_ITEM;
	static const char* const INS_ITEM;
	static const char* const DEL_ITEM;
	static const char* const CAPTION;
	static const char* const FILTER;

// ******* MEMBERS *******
private:
	QLineEdit*  const qmake_edit_;
	ToolsTable* const before_list_;
	ToolsTable* const after_list_;

// ******* METHODS *******
public:
	bool accept();
private:
	void read_data();
	void save_data( const QString& );
private slots:
	void qmake_dir_slot ();
};

#endif // INCLUDED_ProjectTools_h
