/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : Properties.h
 * DATE   : 26.09.2006
 *******************************************************************/
#ifndef INCLUDED_Properties_h
#define INCLUDED_Properties_h

/*------- include files:
-------------------------------------------------------------------*/
#ifndef INCLUDED_QDialog
#define INCLUDED_QDialog
#include <QDialog>
#endif // INCLUDED_QDialog

#ifndef INCLUDED_QFont
#define INCLUDED_QFont
#include <QFont>
#endif // INCLUDED_QFont

/*------- forward declarations:
-------------------------------------------------------------------*/
class PropertiesGeneral;
class PropertiesFileTree;
class PropertiesClassTree;
class PropertiesEdit;
class PropertiesBuildTab;
class PropertiesMsgTab;
class PropertiesSearchTab;

class QVBoxLayout;
class QHBoxLayout;
class QLabel;
class QPushButton;
class QShowEvent;
class QListWidget;
class QStackedWidget;
class QWidget;

/*------- class declaration:
-------------------------------------------------------------------*/
class Properties : public QDialog
{
	Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION *******
public:
	Properties( QWidget* );
private:
	Properties( const Properties& );
	Properties& operator=( const Properties& );

// ******* CONSTANTS *******
private:
	static const char* const CAPTION;
	static const char* const ACCEPT;
	static const char* const EXIT;
	static const char* const DEFAULT_FONT;
	static const char* const GROUP;
	static const char* const EDITOR_TEXT_FONT_KEY;
	static const char* const PROPTAB_NAME[];

// ******* MEMBERS *******
private:
	QHBoxLayout*         const d_main_layout;
	QListWidget*         const d_wlist;
	QStackedWidget*      const d_wstack;
	QVBoxLayout*         const d_btn_layout;
	PropertiesGeneral*   const d_prop_gen;
	PropertiesFileTree*  const d_prop_ftree;
	PropertiesClassTree* const d_prop_ctree;
	PropertiesEdit*      const d_prop_edit;
	PropertiesBuildTab*  const d_prop_build;
	PropertiesMsgTab*    const d_prop_msg;
	PropertiesSearchTab* const d_prop_search;
	QPushButton*         const d_accept;
	QPushButton*         const d_exit;
// ****** METHODS *******
private slots:
	void row_changed ( int );
	void      accept ();
signals:
	void   save_data ();
};

#endif // INCLUDED_Properties_h
