/*******************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : QBTParserFunDef.h
 * DATE   : 13.06.2007
 *******************************************************************/
#ifndef INCLUDED_QBTParserFunDef_h
#define INCLUDED_QBTParserFunDef_h

/*------- include files:
-------------------------------------------------------------------*/
#include "QBTCodeBlockInfo.h"
#include <QWidget>
#include <QThread>
#include <vector>

/*------- class declaration:
-------------------------------------------------------------------*/
class QBTParserFunDef : public QThread
{
   Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION *******
public:
   QBTParserFunDef( QObject* in_parent = 0 ) : QThread( in_parent )
   {}
private:
   QBTParserFunDef( const QBTParserFunDef& );
   QBTParserFunDef& operator=( const QBTParserFunDef& );

// ******* TYPES *******
public:
   typedef std::vector<QBTCodeBlockInfo> CodeBlockVector;
// ******* MEMBERS *******
private:
   QString         text_;
   CodeBlockVector data_;
   CodeBlockVector muster_;
   
// ******* METHODS *******
public:
   void   parse_it ( const QString&, const CodeBlockVector& );
   void   data     ( CodeBlockVector& ) const;
private:
   void   run      ();
   qint32 next_idx ( qint32 ) const;
};

#endif // INCLUDED_QBTParserFunDef_h
