#ifndef INCLUDED_QBtMessageTab_h
#define INCLUDED_QBtMessageTab_h

/********************************************************************
 * Copyright (C) Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : QBtMessageTab.h
 * DATE   : 3.09.2006
 *******************************************************************/

/*------- include files:
-------------------------------------------------------------------*/
#include <QWidget>

/*------- forward declarations:
-------------------------------------------------------------------*/
class QTabBar;
class QStackedWidget;
class BrowserDbg;
class BrowserMessages;
class QEvent;

/*------- class declaration:
-------------------------------------------------------------------*/
class QBtMessageTab : public QWidget
{
   Q_OBJECT

// ******* CONSTRUCTION/DESTRUCTION *******
public:
   QBtMessageTab( QWidget* = 0 );
   ~QBtMessageTab();
private:
   QBtMessageTab( const QBtMessageTab& );
   QBtMessageTab& operator=( const QBtMessageTab& );

// ******* CONSTANTS *******
private:
   static const char* const BUILD_TAB_LABEL;
   static const char* const MSG_TAB_LABEL;
   static const char* const SEARCH_TAB_LABEL;
   static const char* const DBG_TAB_LABEL;

// ******* MEMBERS *******
private:
   QTabBar*         const tab_bar_;
   QStackedWidget*  const widget_stack_;
   const qint32           build_tab_idx_;
   const qint32           msg_tab_idx_;
   const qint32           search_tab_idx_;
   const qint32           dbg_tab_idx_;
   BrowserDbg*      const dbg_browser_;
   BrowserMessages* const msg_browser_;

// ******* METHODS *******
public:
   void retranslate();
private:
   void customEvent( QEvent* );
private slots:
   void tab_changed( int );
};

#endif // INCLUDED_QBtMessageTab_h
