/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : QBtProjectTab.h
 * DATE   : 3.09.2006
 *******************************************************************/
#ifndef INCLUDED_QBtProjectTab_h
#define INCLUDED_QBtProjectTab_h

/*------- include files:
-------------------------------------------------------------------*/
#include <QWidget>

/*------- forward declarations:
-------------------------------------------------------------------*/
class QTabBar;
class QStackedWidget;

/*------- class declaration:
-------------------------------------------------------------------*/
class QBtProjectTab : public QWidget
{
   Q_OBJECT

// ******* CONSTRUCTION/DESTRUCTION *******
public:
   QBtProjectTab( QWidget* = 0 );
private:
   QBtProjectTab( const QBtProjectTab& );
   QBtProjectTab& operator=( const QBtProjectTab& );

// ******* CONSTANTS *******
private:
   static const char* const FILES_TAB_LABEL;
   static const char* const CLASSES_TAB_LABEL;

// ******* MEMBERS *******
private:
   QTabBar*        const tab_bar_;
   QStackedWidget* const widget_stack_;
   const qint32          files_tab_idx_;
   const qint32          classes_tab_idx_;

// ******* METHODS *******
public:
   void retranslate();
private slots:
   void tab_changed( int );
};

#endif // INCLUDED_QBtProjectTab_h
