/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : QtDirs.cpp
 * DATE   : 11.03.2007
 *******************************************************************/

/*------- include files:
-------------------------------------------------------------------*/
#include "QtDirs.h"
#include <QApplication>
#include <QtDebug>

/*------- local constants:
-------------------------------------------------------------------*/
QtDirs* QtDirs::d_instance = 0;

//*******************************************************************
// QtDirs                                        CONSTRUCTOR private
//*******************************************************************
QtDirs::QtDirs()
: QObject()
, QStringList ()
{
	setParent( qApp );
	*this
		<< "QMAKE_CXXFLAGS"
		<< "QMAKE_CXXFLAGS_DEBUG"
		<< "QMAKE_CXXFLAGS_RELEASE"
		<< "QMAKE_CXXFLAGS_WARN_OFF"
		<< "QMAKE_CXXFLAGS_WARN_ON"
		<< "QMAKE_CXXFLAGS_SHLIB"
		<< "QMAKE_CXXFLAGS_MT"
		<< "QMAKE_CXXFLAGS_MT_DBG"
		<< "QMAKE_CXXFLAGS_MT_DLL"
		<< "QMAKE_CXXFLAGS_MT_DLLDBG"
		<< "QMAKE_CXXFLAGS_THREAD"
		<< "QMAKE_LFLAGS_DEBUG"
		<< "QMAKE_LFLAGS_RELEASE"
		<< "QMAKE_LFLAGS_THREAD"
		<< "QMAKE_LFLAGS_PLUGIN"
		<< "QMAKE_LFLAGS_SHLIB"
		<< "QMAKE_LFLAGS_SHAPP"
		<< "QMAKE_LFLAGS_QT_DLL"
		<< "QMAKE_LFLAGS_SONAME"
		<< "QMAKE_LFLAGS_CONSOLE"
		<< "QMAKE_LFLAGS_CONSOLE_DLL"
		<< "QMAKE_LFLAGS_WINDOWS"
		<< "QMAKE_LFLAGS_WINDOWS_DLL"
		<< "QMAKE_CFLAGS_DEBUG"
		<< "QMAKE_CFLAGS_RELEASE"
		<< "QMAKE_CFLAGS_WARN_ON"
		<< "QMAKE_CFLAGS_WARN_OFF"
		<< "QMAKE_CFLAGS_MT"
		<< "QMAKE_CFLAGS_MT_DEBUG"
		<< "QMAKE_CFLAGS_MT_DLL"
		<< "QMAKE_CFLAGS_MT_DLLDBG"
		<< "QMAKE_CFLAGS_SHLIB"
		<< "QMAKE_CFLAGS_THREAD";
}
// end of QtDirs

//*******************************************************************
// instance                                            PUBLIC static
//*******************************************************************
QtDirs* QtDirs::instance()
{
	if( 0 == d_instance ) d_instance = new QtDirs;
	return d_instance;
}
// end of instance
