/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : QtMake.cpp
 * DATE   : 11.03.2007
 *******************************************************************/

/*------- include files:
-------------------------------------------------------------------*/
#include "QtMake.h"
#include <QApplication>
#include <QtDebug>

/*------- local constants:
-------------------------------------------------------------------*/
QtMake* QtMake::d_instance = 0;

//*******************************************************************
// QtMake                                        CONSTRUCTOR private
//*******************************************************************
QtMake::QtMake()
: QObject()
, QSet< QString > ()
{
	setParent( qApp );
	*this
		<< "QMAKE"
		<< "QMAKE_SPEC"
		<< "QMAKE_CXXFLAGS"
		<< "QMAKE_CXXFLAGS_DEBUG"
		<< "QMAKE_CXXFLAGS_RELEASE"
		<< "QMAKE_CXXFLAGS_WARN_OFF"
		<< "QMAKE_CXXFLAGS_WARN_ON"
		<< "QMAKE_CXXFLAGS_SHLIB"
		<< "QMAKE_CXXFLAGS_MT"
		<< "QMAKE_CXXFLAGS_MT_DBG"
		<< "QMAKE_CXXFLAGS_MT_DLL"
		<< "QMAKE_CXXFLAGS_MT_DLLDBG"
		<< "QMAKE_CXXFLAGS_THREAD"
		<< "QMAKE_LFLAGS_DEBUG"
		<< "QMAKE_LFLAGS_RELEASE"
		<< "QMAKE_LFLAGS_THREAD"
		<< "QMAKE_LFLAGS_PLUGIN"
		<< "QMAKE_LFLAGS_SHLIB"
		<< "QMAKE_LFLAGS_SHAPP"
		<< "QMAKE_LFLAGS_QT_DLL"
		<< "QMAKE_LFLAGS_SONAME"
		<< "QMAKE_LFLAGS_CONSOLE"
		<< "QMAKE_LFLAGS_CONSOLE_DLL"
		<< "QMAKE_LFLAGS_WINDOWS"
		<< "QMAKE_LFLAGS_WINDOWS_DLL"
		<< "QMAKE_CFLAGS_DEBUG"
		<< "QMAKE_CFLAGS_RELEASE"
		<< "QMAKE_CFLAGS_WARN_ON"
		<< "QMAKE_CFLAGS_WARN_OFF"
		<< "QMAKE_CFLAGS_MT"
		<< "QMAKE_CFLAGS_MT_DEBUG"
		<< "QMAKE_CFLAGS_MT_DLL"
		<< "QMAKE_CFLAGS_MT_DLLDBG"
		<< "QMAKE_CFLAGS_SHLIB"
		<< "QMAKE_CFLAGS_THREAD"
		<< "QMAKE_APP_FLAG"
		<< "QMAKE_APP_OR_DLL"
		<< "QMAKE_AR_CMD"
		<< "QMAKE_CLEAN"
		<< "QMAKE_EXTENSION_SHLIB"
		<< "QMAKE_EXT_MOC"
		<< "QMAKE_EXT_UI"
		<< "QMAKE_EXT_PRL"
		<< "QMAKE_EXT_LEX"
		<< "QMAKE_EXT_YACC"
		<< "QMAKE_EXT_OBJ"
		<< "QMAKE_EXT_CPP"
		<< "QMAKE_EXT_H"
		<< "QMAKE_FAILED_REQUIREMENTS"
		<< "QMAKE_FILETAGS"
		<< "QMAKE_FRAMEWORK_VERSION"
		<< "QMAKE_INCDIR"
		<< "QMAKE_INCDIR_OPENGL"
		<< "QMAKE_INCDIR_QT"
		<< "QMAKE_INCDIR_THREAD"
		<< "QMAKE_INCDIR_X11"
		<< "QMAKE_LIBDIR"
		<< "QMAKE_LIBDIR_FLAGS"
		<< "QMAKE_LIBDIR_OPENGL"
		<< "QMAKE_LIBDIR_QT"
		<< "QMAKE_LIBDIR_X11"
		<< "QMAKE_LIBS"
		<< "QMAKE_LIBS_CONSOLE"
		<< "QMAKE_LIBS_OPENGL"
		<< "QMAKE_LIBS_OPENGL_QT"
		<< "QMAKE_LIBS_QT"
		<< "QMAKE_LIBS_QT_DLL"
		<< "QMAKE_LIBS_QT_OPENGL"
		<< "QMAKE_LIBS_QT_THREAD"
		<< "QMAKE_LIBS_RT"
		<< "QMAKE_LIBS_RTMT"
		<< "QMAKE_LIBS_THREAD"
		<< "QMAKE_LIBS_WINDOWS"
		<< "QMAKE_LIBS_X11"
		<< "QMAKE_LIBS_X11SM"
		<< "QMAKE_LIB_FLAG"
		<< "QMAKE_LINK_SHLIB_CMD"
		<< "QMAKE_POST_LINK"
		<< "QMAKE_PRE_LINK"
		<< "QMAKE_LN_SHLIB"
		<< "QMAKE_MAKEFILE"
		<< "QMAKE_MOC_SRC"
		<< "QMAKE_QMAKE"
		<< "QMAKE_QT_DLL"
		<< "QMAKE_RUN_CC"
		<< "QMAKE_RUN_CC_IMP"
		<< "QMAKE_RUN_CXX"
		<< "QMAKE_RUN_CXX_IMP"
		<< "QMAKE_TARGET"
		<< "QMAKE_UIC";
	squeeze();
}
// end of QtFlags

//*******************************************************************
// instance                                            PUBLIC static
//*******************************************************************
QtMake* QtMake::instance()
{
	if( 0 == d_instance ) d_instance = new QtMake;
	return d_instance;
}
// end of instance
