/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : Settings.h
 * DATE   : 20.09.2006
 *******************************************************************/
#ifndef INCLUDED_Settings_H
#define INCLUDED_Settings_H

/*------- include files:
-------------------------------------------------------------------*/
#ifndef INCLUDED_QObject
#define INCLUDED_QObject
#include <QObject>
#endif // INCLUDED_QObject

#ifndef INCLUDED_QSettings
#define INCLUDED_QSettings
#include <QSettings>
#endif // INCLUDED_QSettings

#ifndef INCLUDED_QVariant
#define INCLUDED_QVariant
#include <QVariant>
#endif // INCLUDED_QVariant

/*------- class declaration:
-------------------------------------------------------------------*/
class Settings : protected QSettings
{
	Q_OBJECT
// ******* CONSTRUCTION / DESTRUCTION *******
public:
	Settings() : QSettings() {}
private:
	Settings( const Settings& );
	Settings& operator=( const Settings& );
public:	
	bool save  ( const QString&, const QVariant& );
	bool read  ( const QString&, QVariant& );
};

#endif // INCLUDED_Settings_H
